# SoMFNode Class Reference
[Field classes]

`#include <Inventor/fields/SoMFNode.h>`

Inheritance diagram for SoMFNode:

List of all members.

## Detailed Description

The SoMFNode class is a container for nodes.

This field container stores an array of pointers to nodes. It takes care of the necessary functionality for handling copy, import and export operations.

Note that node pointers stored in field instances of this type may be `NULL` pointers.

See also:
  SoNode, SoSFNode

## Public Member Functions

virtual void | fixCopy (SbBool copyconnections)
virtual SbBool | referencesCopy (void) const
void | addNode (SoNode *node)
void | insertNode (SoNode *node, int idx)
SoNode * | getNode (int idx) const
int | findNode (const SoNode *node) const
int | getNumNodes (void) const
void | removeNode (int index)
void | removeNode (SoNode *node)
void | removeAllNodes (void)
void | replaceNode (int idx, SoNode *newnode)
void | replaceNode (SoNode *oldnode, SoNode *newnode)
virtual void | deleteValues (int start, int num=-1)
virtual void | insertSpace (int start, int num)

## Static Public Member Functions

void | initClass (void)

## Member Function Documentation

void SoMFNode::initClass | ( | void |  | ) | `[static]`

| Internal method called upon initialization of the library (from SoDB::init()) to set up the type system. Reimplemented from SoMField.

void SoMFNode::fixCopy | ( | SbBool | copyconnections | ) | `[virtual]`

This method is internally called after SoField::copyFrom() during scene graph copies, and should do the operations necessary for fixing up the field instance after it has gotten a new value.

The default method in the SoField superclass does nothing.

The application programmer should normally not need to consider this method, unless he constructs a complex field type which contains new references to container instances (i.e. nodes or engines). Overriding this method is then necessary to update the reference pointers, as they could have been duplicated during the copy operation.

Reimplemented from SoField.

SbBool SoMFNode::referencesCopy | ( | void |  | ) | const`[virtual]`

| Returns `TRUE` if this field has references to any containers in the scene graph which are also duplicated during the copy operation. Note that this method only is valid to call during copy operations. See also the note about the relevance of the fixCopy() method for application programmers, as it is applicable on this method aswell. Reimplemented from SoField.

void SoMFNode::addNode | ( | SoNode * | node | ) |

Adds a node at the end of the array.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

void SoMFNode::insertNode | ( | SoNode * | node,
|  | int | idx
| ) |

Inserts a node at index idx.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

SoNode * SoMFNode::getNode | ( | int | idx | ) | const

Returns the node at index idx.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

int SoMFNode::findNode | ( | const SoNode * | node | ) | const

Returns the index for the first instance of node in the field, or -1 if not found.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

int SoMFNode::getNumNodes | ( | void |  | ) | const

Returns the number of nodes in this field.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

void SoMFNode::removeNode | ( | int | idx | ) |

Removes the node at index idx.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

void SoMFNode::removeNode | ( | SoNode * | node | ) |

Removes the first instance of node in the field.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

void SoMFNode::removeAllNodes | ( | void |  | ) |

Removes all nodes from the field.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

void SoMFNode::replaceNode | ( | int | idx,
|  | SoNode * | newnode
| ) |

Replaces the node at index idx with newnode.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

void SoMFNode::replaceNode | ( | SoNode * | oldnode,
|  | SoNode * | newnode
| ) |

Replaces the first instance of oldnode with newnode.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

virtual void SoMFNode::deleteValues | ( | int | start,
|  | int | num = -1
| ) | `[virtual]`

| Remove value elements from index start up to and including index start + num - 1. Elements with indices larger than the last deleted element will be moved downwards in the value array. If num equals -1, delete from index start and to the end of the array. Reimplemented from SoMField.

virtual void SoMFNode::insertSpace | ( | int | start,
|  | int | num
| ) | `[virtual]`

| Insert num "slots" for new value elements from start. The elements already present from start will be moved "upward" in the extended array. Reimplemented from SoMField.

The documentation for this class was generated from the following files:

- SoMFNode.h
- SoMFNode.cpp